/* AMX Mod X
*
*	UFPS Spawn Control
*
*	      UFPS Map Manager
*	      
*	        .
*
*	   :	"AuroRTV", "0.1", "K&Bear"
*
*
*	:
*		umm_control_spawn		(default - 1)	- /  
*		umm_control_timeout		(default - 3)	-          
*
*	This file is part of UFPS.Team Plugins
*/

#include <amxmodx>
#include <fakemeta>

#define PLUGIN_NAME			"UFPS Spawn Control"
#define PLUGIN_VERSION		"1.0"
#define PLUGIN_AUTHOR		"UFPS.Team"

#define TASK_CTRL			13827

new g_spawns

new bool:g_control

new pcv_control_spawn
new pcv_control_timeout


public plugin_init ( )
{
	register_plugin ( PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR )
	register_logevent ( "event_start_round", 2,	 "0=World triggered",	"1=Round_Start" )
	register_event ( "TextMsg", "event_restart_game", "a", "2=#Game_Commencing", "2=#Game_will_restart_in" )
	
	pcv_control_spawn	= register_cvar ( "umm_control_spawn",		"1" )
	pcv_control_timeout	= register_cvar ( "umm_control_timeout",	"3" )
}

public plugin_cfg ( )
{
	g_spawns = 0

	new ent = 0
	while ( ( ent = engfunc ( EngFunc_FindEntityByString, ent, "classname", "info_player_deathmatch" ) ) != 0 )
	{
		g_spawns++
	}

	ent = 0
	while ( ( ent = engfunc ( EngFunc_FindEntityByString, ent, "classname", "info_player_start" ) ) != 0 )
	{
		g_spawns++
	}
}

public event_restart_game ( )
{
	g_control = false

	if ( task_exists ( TASK_CTRL ) )
		remove_task ( TASK_CTRL )

	if ( get_pcvar_float ( pcv_control_timeout ) < 0.1 )
		set_pcvar_float ( pcv_control_timeout, 0.1 )

	set_task ( 60.0 * get_pcvar_float ( pcv_control_timeout ), "task_control_enable", TASK_CTRL )

	return PLUGIN_CONTINUE
}

public event_start_round ( )
{
	if ( !g_control || !get_pcvar_num ( pcv_control_spawn ) )
		return PLUGIN_CONTINUE

	new players = get_playersnum ( 1 )

	if ( players > g_spawns )
	{
		new mapname[32]
		get_mapname ( mapname, sizeof ( mapname ) - 1 )

		log_amx ( "UFPS Spawn Conrtol: [START VOTE] | Map %s | Spawns %d | Players %d", mapname, g_spawns, players )

		server_cmd ( "umm_votemap" )
		server_exec ( )

		event_restart_game ( ) // =)
	}

	return PLUGIN_CONTINUE
}

public task_control_enable ( )
{
	g_control = true
}

public plugin_end ( )
{
	if ( task_exists ( TASK_CTRL ) )
		remove_task ( TASK_CTRL )
}
